#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include "dio.h"

void	READ_CMD(char *);
short	ASCII_TO_HEX(char);
void	TEST_CMD(HWND, int, int, int, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
WORD	set_8254(WORD wPort, WORD wVal);
WORD	disable_8254(WORD wPort);

short	nDMA=-1, nIRQ=5;
WORD	wBase=0x2C0;
int	iLine;

/* -------------------------------------------------------------------- */

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
		    PSTR szCmdLine, int iCmdShow)
     {
     static char szAppName[] = "TestDIO48";
     HWND	 hwnd ;
     MSG	 msg ;
     WNDCLASSEX  wndclass ;

     wndclass.cbSize	    = sizeof(wndclass);
     wndclass.style	    = CS_HREDRAW|CS_VREDRAW;
     wndclass.lpfnWndProc   = WndProc;
     wndclass.cbClsExtra    = 0;
     wndclass.cbWndExtra    = 0;
     wndclass.hInstance     = hInstance;
     wndclass.hIcon	    = LoadIcon(NULL, IDI_APPLICATION);
     wndclass.hCursor	    = LoadCursor(NULL, IDC_ARROW);
     wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
     wndclass.lpszMenuName  = NULL;
     wndclass.lpszClassName = szAppName;
     wndclass.hIconSm	    = LoadIcon(NULL, IDI_APPLICATION);

     RegisterClassEx(&wndclass) ;
     hwnd=CreateWindow(szAppName,"TESTDIO48 = [BASE:3] [DMA:1] [IRQ:2]",
			  WS_OVERLAPPEDWINDOW,
			  CW_USEDEFAULT, CW_USEDEFAULT,
			  CW_USEDEFAULT, CW_USEDEFAULT,
			  NULL, NULL, hInstance, NULL) ;
     ShowWindow(hwnd,iCmdShow);
     UpdateWindow(hwnd);

     while (GetMessage(&msg, NULL, 0, 0))
	  {
	  TranslateMessage(&msg);
	  DispatchMessage(&msg);
	  }
     return msg.wParam;
     }

/* -------------------------------------------------------------------- */

LRESULT CALLBACK WndProc(HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
static int  cxChar, cyChar, cxClient, cyClient, cxBuffer, cyBuffer,
	    xCaret, yCaret;
static char cBuf[80];
HDC	    hdc;
TEXTMETRIC  tm;
PAINTSTRUCT ps;
int	    i;

switch (iMsg)
  {
  case WM_CREATE :		       // window initial
       hdc=GetDC(hwnd);
       SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));
       GetTextMetrics(hdc, &tm);
       cxChar=tm.tmAveCharWidth;
       cyChar=tm.tmHeight;
       ReleaseDC(hwnd, hdc);
       return 0;
  case WM_SIZE :
       cxClient=LOWORD(lParam); 	// window size in pixels
       cyClient=HIWORD(lParam);
       cxBuffer=max(1,cxClient/cxChar); // window size in characters
       cyBuffer=max(1,cyClient/cyChar);
       return 0;
  case WM_SETFOCUS :
       CreateCaret(hwnd, NULL, cxChar, cyChar);
       SetCaretPos(xCaret * cxChar, yCaret * cyChar);
       ShowCaret(hwnd);
       return 0;
  case WM_KILLFOCUS :
       HideCaret(hwnd);
       DestroyCaret();
       return 0;
  case WM_CHAR :			// user press KEYBOARD
       for (i = 0 ; i < (int) LOWORD(lParam) ; i++)
       {
       switch (wParam)
	 {
	 case '\b' :                    // backspace pressed
	   if (xCaret > 0)
	   {
	   xCaret-- ;
	   cBuf[xCaret]=' ';
	   HideCaret(hwnd);
	   hdc=GetDC(hwnd);
	   SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));
	   TextOut(hdc, xCaret * cxChar, yCaret * cyChar,cBuf+xCaret,1);
	   ShowCaret(hwnd);
	   ReleaseDC(hwnd, hdc);
	   }
	   break ;
	 case '\r' :                    // carriage return  pressed
	   cBuf[xCaret]=0;
	   if (xCaret!=0) {xCaret=0; yCaret++;}
	   READ_CMD(cBuf);
	   TEST_CMD(hwnd,xCaret, cxChar, yCaret,cyChar);
	   xCaret=0; yCaret+=iLine;
	   if (yCaret >= cyBuffer) InvalidateRect(hwnd, NULL, TRUE);
	   break ;
	 case '\x1B' :                  // escape pressed
	   InvalidateRect (hwnd, NULL, TRUE) ;
	   xCaret=yCaret=0;
	   break ;
	 default :			// other KEY pressed
	   cBuf[xCaret]=(char) wParam;
	   HideCaret(hwnd);
	   hdc=GetDC (hwnd);
	   SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));
	   TextOut(hdc,xCaret*cxChar,yCaret*cyChar,cBuf+xCaret,1);
	   ShowCaret(hwnd);
	   ReleaseDC(hwnd, hdc);
	   xCaret++;
	   break ;
	 }
       }
       SetCaretPos(xCaret*cxChar, yCaret*cyChar);
       return 0;
  case WM_PAINT :			// clr and show HELP
       InvalidateRect(hwnd, NULL, TRUE);
       hdc=BeginPaint(hwnd, &ps);
       SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));

       sprintf(cBuf,"NOW --> Base=%x, DMA=%d, IRQ=%d",wBase,nDMA,nIRQ);
       TextOut(hdc,0,0,cBuf,strlen(cBuf));
       xCaret = 0 ; yCaret=1;
       SetCaretPos(0,yCaret*cyChar);

       EndPaint(hwnd, &ps);
       return 0;
  case WM_DESTROY :
       PostQuitMessage(0);
       return 0 ;
  }
return DefWindowProc(hwnd, iMsg, wParam, lParam);
}

/* -------------------------------------------------------------------- */
/* [0][1][2]=base_address, [4]=DMA, [6][7]=IRQ				*/
void READ_CMD(char szCmd[])
{
short nT1,nT2,nT3;

if (szCmd[0]==0) return;	// only press [Enter]

nT1=ASCII_TO_HEX(szCmd[0]);	// HEX format
nT2=ASCII_TO_HEX(szCmd[1]);
nT3=ASCII_TO_HEX(szCmd[2]);
wBase=nT1*256+nT2*16+nT3;

nDMA=ASCII_TO_HEX(szCmd[4]);	// DECIMAL format
if (nDMA==0) nDMA=-1;		// no DMA is used

nT1=ASCII_TO_HEX(szCmd[6]);	// DECIMAL format
nT2=ASCII_TO_HEX(szCmd[7]);
nIRQ=nT1*10+nT2;
if (nIRQ==0) nIRQ=-1;		// no IRQ is used
}

short ASCII_TO_HEX(char cChar)
{
if (cChar<='9') return(cChar-'0');
else if (cChar<='F') return(cChar-'A'+10);
else return(cChar-'a'+10);
}

/* -------------------------------------------------------------------- */

void TEST_CMD(HWND hwnd, int x, int dx, int y, int dy)
{
char cBuf[80],cShow[80];
HDC hdc;
WORD wRetVal,wChannel,wConfig,wType,wBuf[10],wCount,i,j,k;
short nRetVal;
float fRetVal,fVal,fBuf[10];

iLine=0;
hdc=GetDC(hwnd);
HideCaret(hwnd);
SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));

sprintf(cShow,"----------------------------------------------------------");
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;
sprintf(cShow,"Now Setting Is --> Base=%x, DMA=%d, IRQ=%d",wBase,nDMA,nIRQ);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

wRetVal=DIO_GetDllVersion();
sprintf(cShow,"1. DLL Version=%x",wRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

nRetVal=DIO_ShortSub2(1,2);
sprintf(cShow,"2. SHORT_SUB_2(1,2) = %d",nRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

fRetVal=DIO_FloatSub2((float)1.0, (float)2.0);
sprintf(cShow,"3. FLOAT_SUB_2(1.0,2.0) = %f",fRetVal);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

wRetVal=DIO_OpenVxd();	 // NOTE : this function must call once before
			 //	   the other Vxd-service functions are
			 //	   called. Refer to manual for details.
if (wRetVal==0) sprintf(cShow,"4. [NAPDIO.VXD] Open OK");
else sprintf(cShow,"4. [NAPDIO.VXD] Open Error");
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

wRetVal=DIO_GetVxdVersion(&i);
if (wRetVal==0) sprintf(cShow,"5. Vxd Version=%x",i);
else sprintf(cShow,"5. Get Vxd Version Error");
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

DIO_OutputByte(wBase+3,0x80); /* PORT A,B,C =  output port */
DIO_OutputByte(wBase+7,0x9B); /* PORT D,E,F =  input  port */

DIO_OutputByte(wBase  ,0x55);	/* PORT_A=0x55 */
DIO_OutputByte(wBase+1,0xaa);	/* PORT_B=0xAA */
DIO_OutputByte(wBase+2,0x55);	/* PORT_C=0x55 */
i=DIO_InputByte(wBase+4);	/* input PORT_D */
j=DIO_InputByte(wBase+5);	/* input PORT_E */
k=DIO_InputByte(wBase+6);	/* input PORT_F */
sprintf(cShow,"6. DO=55aa55 --> DI=%x%x%x",i,j,k);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

DIO_OutputByte(wBase  ,0xaa);	/* PORT_A=0x55 */
DIO_OutputByte(wBase+1,0x55);	/* PORT_B=0xAA */
DIO_OutputByte(wBase+2,0xaa);	/* PORT_C=0x55 */
i=DIO_InputByte(wBase+4);	/* input PORT_D */
j=DIO_InputByte(wBase+5);	/* input PORT_E */
k=DIO_InputByte(wBase+6);	/* input PORT_F */
sprintf(cShow,"7. DO=aa55aa --> DI=%x%x%x",i,j,k);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

DIO_OutputByte(wBase  ,0x00);	/* PORT_A=0x55 */
DIO_OutputByte(wBase+1,0x00);	/* PORT_B=0xAA */
DIO_OutputByte(wBase+2,0x00);	/* PORT_C=0x55 */
i=DIO_InputByte(wBase+4);	/* input PORT_D */
j=DIO_InputByte(wBase+5);	/* input PORT_E */
k=DIO_InputByte(wBase+6);	/* input PORT_F */
sprintf(cShow,"8. DO=000000 --> DI=%x%x%x",i,j,k);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

DIO_OutputByte(wBase  ,0xff);	/* PORT_A=0x55 */
DIO_OutputByte(wBase+1,0xff);	/* PORT_B=0xAA */
DIO_OutputByte(wBase+2,0xff);	/* PORT_C=0x55 */
i=DIO_InputByte(wBase+4);	/* input PORT_D */
j=DIO_InputByte(wBase+5);	/* input PORT_E */
k=DIO_InputByte(wBase+6);	/* input PORT_F */
sprintf(cShow,"9. DO=ffffff --> DI=%x%x%x",i,j,k);
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

/* to test this program
   1 : I/O base address select 0x2c0
   2 : S1 of SW1=OFF, others ON --> select 32768 Hz CLK source
   3 : Irq select 5
   4 : refer to "DIO-48 user manual" P16-P19, IRQ_TIM.C
*/

disable_8254(2); // close timer2 first */
disable_8254(1);

wRetVal=DIO_InstallIrq(wBase,(WORD)nIRQ);
if (wRetVal==0) sprintf(cShow,"10. Install Irq Ok");
else sprintf(cShow,"10. Install Irq Error");
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

wRetVal=DIO_ResetIntCount();
if (wRetVal==0) sprintf(cShow,"11. ResetIntCount OK");
else sprintf(cShow,"11. ResetIntCount Error");
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

wRetVal=DIO_GetIntCount(&i);
if (wRetVal==0) sprintf(cShow,"12. IntCount=%x",i);
else sprintf(cShow,"12. GetIntCount Error");
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;

set_8254((WORD)1,(WORD)16384);	// 0.5 sec pulse, start time1 first
set_8254((WORD)2,(WORD)2);	// 0.5*2=1 sec pulse

for (j=0; j<8; j++)
{
Sleep(600);
wRetVal=DIO_GetIntCount(&i);
if (wRetVal==0) sprintf(cShow,"13.[%d] IntCount=%x",j,i);
else sprintf(cShow,"13. GetIntCount Error");
TextOut(hdc,x*dx,(y+iLine)*dy,cShow,strlen(cShow)); iLine++;
}

disable_8254(1);
disable_8254(2);

DIO_CloseVxd(); 	// NOTE : this function must call once before
			//	  program exit	(if Vxd-service functions
			//	  are called) Refer to manual for details.

ShowCaret(hwnd);
ReleaseDC (hwnd,hdc);
}

WORD set_8254(WORD wPort, WORD wVal)
{
WORD wControl,wHigh,wLow,wAddr;

switch (wPort)
       {
       case 1 : wControl=0x76; wAddr=wBase+0x0D; break; /* timer 1 */
       case 2 : wControl=0xB6; wAddr=wBase+0x0E; break; /* timer 2 */
       default: return(1);
       }

wLow=wVal&0xff;
wHigh=(wVal>>8)&0xff;
DIO_OutputByte(wBase+0x0F,wControl); /* 8254 control port */
DIO_OutputByte(wAddr,wLow);	     /* 8254 timer_? low byte */
DIO_OutputByte(wAddr,wHigh);	     /* 8254 timer_? high byte */
return(0);
}

WORD disable_8254(WORD wPort)
{
WORD wControl,wAddr;

switch (wPort)
       {
       case 1 : wControl=0x74; wAddr=wBase+0x0D; break; /* timer 1 */
       case 2 : wControl=0xB4; wAddr=wBase+0x0E; break; /* timer 2 */
       default: return(1);
       }
DIO_OutputByte(wBase+0x0F,wControl); /* 8254 control port */
DIO_OutputByte(wAddr,1);	     /* 8254 timer_? low byte */
DIO_OutputByte(wAddr,0);	     /* 8254 timer_? high byte */
return(0);
}

